rawset(_G, "MMT", {version = "6.2.0",
            versiontable = {6, 2, 0}} -- main version, sub version, patch version
)

-- !! Attributions !! --

MMT.attributions = {
{"EeveeEuphoria/Ibly", "Creator", nil, "KH_IBLY"},
{"amperbee", "Helped with previous versions of MMT, and made PBT3.", nil, "KH_AMPERBEE"},
{"sprkizard", "customsave_io.lua", "\x82Source\x80: github.com/sprkizard/srb2-lua-lib", "KH_SPRKIZARD"},
{"ffoxD/aquaponiee", "Spin Steer", "\x82Source\x80: mb.srb2.org/addons/ffoxds-lua-dumpster.1429", "MMT_FFOXD"},
{"Lianvee", "Personal Sounds", "\x82Source\x80: mb.srb2.org/addons/personal-sounds.2924", "MMT_VEE"},
{"Golden", "Classic Ring Attraction", "\x82Source\x80: mb.srb2.org/addons/classic-ring-attraction.1280", "MMT_ATTR"},
{"marchmountain", "Windows XP High Resolution Icon Pack", nil, "MMT_ATTR"},
{"Yuji Takenouchi",  "Music for: Pro Baseball News, and Load", nil, "MMT_YUJI"},
{"Matt Creamer", "Music for: For Your Convienence, Lobby Line", "\x82Website\x80: raddlandstudios.bandcamp.com", "MMT_MATTC"},
{"Karl Brueggemann", "Music for: File Select", "\x82Website\x80: karlbmusic.bandcamp.com", "MMT_KARLB"},
{"Princess Fluffles", "Playtester", nil, "KH_FLUFFLES"},
--{"nia", "Playtester for TKK, and provided transparent sprites for PowerMac G4.", "\x82Website\x80: nia.dog", "KH_NIA"},
}

-- !! Freeslot !! --

freeslot("S_PLAY_ANGLEIDLE", "MT_MMTSPECIALSTAGEENT", "S_MMTENTERANCE", "SPR_MMSP", "MT_FAKE_SHIELD", "MT_FAKE_SHIELD2")

states[S_PLAY_ANGLEIDLE] = {SPR_PLAY, SPR2_WAIT, 16, nil, 0, 0, S_PLAY_ANGLEIDLE}

mobjinfo[MT_FAKE_SHIELD] = {
	doomednum = -1,
	spawnstate = S_WIND1,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = SH_WHIRLWIND,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 4,
	mass = 16,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_FAKE_SHIELD2] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = SH_WHIRLWIND,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 4,
	mass = 16,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

states[S_MMTENTERANCE] = {
    sprite = SPR_MMSP,
    frame = FF_ANIMATE,
    tics = 15,
    var1 = 5,
    var2 = 3,
    nextstate = S_INVISIBLE
}

mobjinfo[MT_MMTSPECIALSTAGEENT] = {
    doomednum = -1,
    spawnstate = S_MMTENTERANCE,
    spawnhealth = 1000,
    radius = 64*FRACUNIT,
    height = 64*FRACUNIT,
    dispoffset = 1,
    flags = MF_NOCLIP|MF_NOGRAVITY
}

-- !! Important Functions !! --

local function table_invert(t)
    local s={}
    for k,v in pairs(t) do
        s[v]=k
    end
    return s
end


local alphanumtable = {
["0"] = 0,
["1"] = 1,
["2"] = 2,
["3"] = 3,
["4"] = 4,
["5"] = 5,
["6"] = 6,
["7"] = 7,
["8"] = 8,
["9"] = 9,
["A"] = 10,
["B"] = 11,
["C"] = 12,
["D"] = 13,
["E"] = 14,
["F"] = 15,
["G"] = 16,
["H"] = 17,
["I"] = 18,
["J"] = 19,
["K"] = 20,
["L"] = 21,
["M"] = 22,
["N"] = 23,
["O"] = 24,
["P"] = 25,
["Q"] = 26,
["R"] = 27,
["S"] = 28,
["T"] = 29,
["U"] = 30,
["V"] = 31,
["W"] = 32,
["X"] = 33,
["Y"] = 34,
["Z"] = 35,
["a"] = 36,
["b"] = 37,
["c"] = 38,
["d"] = 39,
["e"] = 40,
["f"] = 41,
["g"] = 42,
["h"] = 43,
["i"] = 44,
["j"] = 45,
["k"] = 46,
["l"] = 47,
["m"] = 48,
["n"] = 49,
["o"] = 50,
["p"] = 51,
["q"] = 52,
["r"] = 53,
["s"] = 54,
["t"] = 55,
["u"] = 56,
["v"] = 57,
["w"] = 58,
["x"] = 59,
["y"] = 60,
["z"] = 61,

["!"] = -1,
["@"] = -2,
["#"] = -3,
["$"] = -4,
["^"] = -5,
["&"] = -6,
["*"] = -7,
["("] = -8,
[")"] = -9,
-- i could do more but i think we'll be good enough with this for now

}

local numalphatable = table_invert(alphanumtable)

MMT.TweaksTable = {}
MMT.TweaksTableINTNAME = {}
MMT.mmtGlobalSet = {}
MMT.mmtGlobalStore = {}

addHook("NetVars", function(net) -- DO NOT TRY TO USE NETVARS TO SYNC FUNCTIONS. THIS WILL FAIL.
    MMT.mmtGlobalSet = net(MMT.mmtGlobalSet)
    MMT.mmtGlobalStore = net(MMT.mmtGlobalStore)
end)

function MMT.addTweak(tbl)
    -- basic sanity checks
    if not tbl.name then
        assert(nil, "ERROR: Invalid or no name given to tweak!")
    end
    if not tbl.intname then
        assert(nil, "ERROR: No internal name given to tweak!")
    end
    if tbl.default == nil then
        assert(nil, "ERROR: No default value given to tweak!")
    end
    MMT.TweaksTable[tbl.intname] = tbl
    table.insert(MMT.TweaksTableINTNAME, tbl.intname) -- done to allow for indexing, which is the best way to keep things sorted
end

local function prefixnumbers(number)
    local stringnum = tostring(number)
    if number < 10 then
        stringnum = "00" .. $
    elseif number < 100 then
        stringnum = "0" .. $
    end
    return stringnum
end

local function encoder(value, typeof)
    --print(type(value))
    if typeof == "boolean" then
        if value == true then
            return "T"
        elseif not value and type(value) != "number" then
            return "F"
        end
    --elseif typeof == "alphanum" then
    elseif typeof == "number" then
        --print(tonumber(value) + ": " + numalphatable[tonumber(value)])
        return numalphatable[tonumber(value)] or 0 -- done to prevent erroring out
    elseif typeof == "bignumber" then --TODO: UNUSED RIGHT NOW! FIX ME!
        return (type(value) == "number" and prefixnumbers(value)) or 0
    end

    assert(nil, "ERROR: Bad value given to encode!")
end

local function decoder(value, typeof)
    if value == "T" then
        return true
    elseif value == "F" then
        return nil
    elseif tonumber(value) != nil then
        return tonumber(value)
    elseif typeof == "number" then
        return alphanumtable[value]
    elseif typeof == "bignumber" then
        return tonumber(value)
    else
        assert(nil, "ERROR: Bad value given to decode!")
    end
end

function MMT.encodeSettings(table, typeof)
    local thestringofalltime = ""
    for index, value in ipairs(MMT.TweaksTableINTNAME) do
        if typeof == MMT.TweaksTable[value].options then
            local setter = table[value]
            thestringofalltime = $ .. encoder(setter, typeof) --TODO: this gives an error sometimes, i assume because it's trying to load the wrong setting. instead of erroring out, force it to set a default value, and tell the player a setting is corrupted. it comes from " encoded = MMT.encodeSettings(file, "number") "
        end
    end

    --print(thestringofalltime) -- this will be stored in luafiles
    return thestringofalltime
end

function MMT.decodeSettings(player, string2decode, typeof) --TODO: add alphanum here, and add it to the options as well. use it for numbers below 52.
    local setting2check = 1
    local offset = 0
    if typeof == "bignumber" then
        offset = 2
    end
    for index, value in ipairs(MMT.TweaksTableINTNAME) do
        local part = string2decode:sub(setting2check, setting2check+offset)
        local settingtype = MMT.TweaksTable[value].options
        if not MMT.TweaksTable[value].dontsave then
            --print(part)
            --print(MMT.TweaksTable[value].name)
            --print(typeof)
            if typeof == settingtype then
                setting2check = $ + offset + 1
                if not MMT.TweaksTable[value].global then
                    player.mmtSettings[value] = decoder(part, typeof)
                else
                    --TODO: this; but only for singleplayer
                end
            end
        end
    end

    MMT.encodeSettings(player.mmtSettings, typeof) -- TODO: DEBUG, REMOVE ME!
end

function MMT.saveSettings(player)
    local TheTable = {}
    for key, value in pairs(MMT.TweaksTable) do
        if not value.dontsave then
            if player.mmtSettings[value.intname] != nil then
                TheTable[value.intname] = player.mmtSettings[value.intname]
            else
                TheTable[value.intname] = false
            end
        end
    end

    SaveData_I.WriteSaveFile("client/mmt/" + "settings.dat", TheTable)
end

function MMT.loadSettings(player)
    local file = SaveData_I.ReadSaveFile("client/mmt/" + "settings.dat")

    if file then
        --[[for key, value in pairs(file) do
            print(key)
            print(value)
        end]]
        local encoded = MMT.encodeSettings(file, "boolean")
        COM_BufInsertText(player, "mmtDecode " + encoded + " boolean")
        encoded = MMT.encodeSettings(file, "number")
        COM_BufInsertText(player, "mmtDecode " + encoded + " number")
        encoded = MMT.encodeSettings(file, "bignumber")
        COM_BufInsertText(player, "mmtDecode " + encoded + " bignumber")
    end
end

COM_AddCommand("mmtDecode", function(player, var1, var2) -- this is just so we can load in the settings. fucked up i know.
    MMT.decodeSettings(player, var1, var2)
end)

COM_AddCommand("mmtEncode", function(player, var1) --TODO: TEST, REMOVE ME
    MMT.encodeSettings(player.mmtSettings, var1)
end)


function MMT.importSettings(player) -- TODO: this. this will import the old settings from the older version of MMT!
    print("sorry nothing done yet :(")

end

-- !! Other Functions !! --

function MMT.P_SpawnCoolSkidDust(player, radius, sound) -- source code conversion; i assume i'm the one that did this since i didn't credit anyone lol. sorry if i stole this from you
    local particle = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
    local xn = P_RandomChance(FRACUNIT/2)
    local yn = P_RandomChance(FRACUNIT/2)
    if xn then xn = -1 else xn = 1 end
    if yn then yn = -1 else yn = 1 end

    local x = particle.x + (xn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local y = particle.y + (yn * (FixedMul(radius,P_RandomFixed()) << FRACBITS))
    local z = particle.z --+ (P_RandomRange(0, FRACUNIT-1))
    P_MoveOrigin(particle, x, y, z)
    particle.tics = 10
    particle.scale = (2*player.mo.scale)/3
    particle.momx = player.mo.momx/4
    particle.momy = player.mo.momy/4
    P_SetScale(particle, particle.destscale)
    P_SetObjectMomZ(particle, FRACUNIT, false)
    if player.powers[pw_super] then
        P_SetObjectMomZ(particle, FRACUNIT*3, false)
    end

    if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) then -- smoke looks weird underwater
        particle.state = S_SPLISH1
    end

    if sound then
        S_StartSound(player.mo, sfx_s3k7e)
    end
    return particle -- the one thing the original version of this didn't do, smh smh
end


-- !! mmtPBT3 !! --

-- &
local thosbutons = {
    "up","down","left","right",
    "spin","jump",
    "attack","nextwep","prevwep",
    "custom1","custom2","custom3",
    "moving","hmoving","vmoving",
    "attacknormal", "camleft", "camright", "tossflag", "shield" -- EeveeEuphoria additions
}
for k,v in ipairs(thosbutons) do
    thosbutons[v] = true
end

--NOTE: this has been modified specifically for mmt, then khaos, and now back to mmt lol. all "p.bt..." variables have been converted to "p.mmtbt..." so it doesn't conflict with any other mod that uses this system

rawset(_G, "pbtDaemonmmt", function(p)
    --if deepcopy == nil then error("deepcopy missing", 2) end
    -- Does a cool thing
    local cmdbt = p.cmd.buttons
    local cmdfm = p.cmd.forwardmove
    local cmdsm = p.cmd.sidemove

    if not p.mmtbttimestamp then p.mmtbttimestamp = -1 end

    if p.mmtbttimestamp ~= leveltime then
        -- Prevent this from running more than once if multiple daemons are in place (why would there be more than one)

        if not p.mmtbt then
            p.mmtbt = {}
            p.mmtbtx = {}
            p.mmtbtprev = {}
            for _,v in ipairs(thosbutons) do
                p.mmtbt[v] = 0
                p.mmtbtprev[v] = 0
                p.mmtbtx[v] = 0
            end
        end
        local sens = 20

        for i = 1,#thosbutons do
            local ix = thosbutons[i]
            p.mmtbtprev[ix] = p.mmtbt[ix]
        end -- Old values

        p.mmtbt.up = cmdfm > sens and $+1 or 0
        p.mmtbt.down = cmdfm < -sens and $+1 or 0
        p.mmtbt.right = cmdsm > sens and $+1 or 0
        p.mmtbt.left = cmdsm < -sens and $+1 or 0

        if p.mmtbt.up > 0 and p.mmtbt.down > 0 then p.mmtbt.up = 0; p.mmtbt.down = 0 end
        if p.mmtbt.right > 0 and p.mmtbt.left > 0 then p.mmtbt.right = 0; p.mmtbt.left = 0 end

        p.mmtbt.spin = (cmdbt & BT_USE) > 0 and $+1 or 0
        p.mmtbt.jump = (cmdbt & BT_JUMP) > 0 and $+1 or 0
        p.mmtbt.attack = (cmdbt & BT_ATTACK) > 0 and $+1 or 0
        p.mmtbt.attacknormal = (cmdbt & BT_FIRENORMAL) > 0 and $+1 or 0

        p.mmtbt.tossflag = (cmdbt & BT_TOSSFLAG) > 0 and $+1 or 0

        p.mmtbt.camleft = (cmdbt & BT_CAMLEFT) > 0 and $+1 or 0
        p.mmtbt.camright = (cmdbt & BT_CAMRIGHT) > 0 and $+1 or 0

        p.mmtbt.nextwep = (cmdbt & BT_WEAPONNEXT) > 0 and $+1 or 0
        p.mmtbt.prevwep = (cmdbt & BT_WEAPONPREV) > 0 and $+1 or 0

        p.mmtbt.custom1 = (cmdbt & BT_CUSTOM1) > 0 and $+1 or 0
        p.mmtbt.custom2 = (cmdbt & BT_CUSTOM2) > 0 and $+1 or 0
        p.mmtbt.custom3 = (cmdbt & BT_CUSTOM3) > 0 and $+1 or 0

        if SUBVERSION >= 14 or VERSION >= 203 then
            p.mmtbt.shield = (cmdbt & BT_SHIELD) > 0 and $+1 or 0
        else
            p.mttbt.shield = 0
        end

        p.mmtbt.hmoving = (p.mmtbt.left or p.mmtbt.right) and $~=nil and $+1 or 0
        p.mmtbt.vmoving = (p.mmtbt.up or p.mmtbt.down) and $~=nil and $+1 or 0
        p.mmtbt.moving = (p.mmtbt.up or p.mmtbt.down or p.mmtbt.left or p.mmtbt.right) and $~=nil and $+1 or 0

        local sum = 0
        local sidesum = 0

        if cmdsm < 0 then sidesum = 45 end
        if cmdsm > 0 then sidesum = -45 end

        if cmdfm == 0 then sidesum = $*2 end
        if cmdfm < 0 then sidesum = -sidesum;sum = 180 end

        local res = sum + sidesum
        --return FixedAngle( res*FRACUNIT )
        p.mmtbt.dirAsAngle = FixedAngle( res*FRACUNIT )

        p.mmtbttimestamp = leveltime
    end
end)

--[[
&pbt usage:

p.mmtbt holds button held time
p.mmtbtprev holds the value in the previous frame for that respective button

Want to check if a player is holding jump?
p.mmtbt.jump > 0

Want to check for a tap on the jump button (not held, but the instant it is pressed)?
p.mmtbt.jump == 1

Want to check when jump was just released?
p.mmtbt.jump < p.mmtbtprev.jump
normally btprev is smaller than bt when the button is held, so if it is larger, it must have been released


or use one of the shortcut functions like a baby
]]

local function checks(p, key)
    if not p then error("Bad argument #1 (expected player)", 3) end
    if not p.mmtbt then
        error("Are you running pbtDaemonmmt()?", 3)
    end
    if key == nil then error("Key argument is nil", 3) end
    if not thosbutons[key] then
        error("Button "..key.." not in the list", 3)
    end
end

rawset(_G, "PBTmmt_Up", function(p, key) checks(p,key)
    return not p.mmtbt[key] -- If 0, true
end)
rawset(_G, "PBTmmt_Down", function(p, key) checks(p,key)
    return not not p.mmtbt[key] -- If >0, true
end)

rawset(_G, "PBTmmt_JustPressed", function(p, key) checks(p,key)
    -- Button has just been pressed after not being pressed
    return p.mmtbt[key] and p.mmtbtprev[key] == 0
end)
rawset(_G, "PBTmmt_JustReleased", function(p, key) checks(p,key)
    -- Button is no longer being pressed after being pressed press press press press press press press press press press
    return p.mmtbt[key] < p.mmtbtprev[key]
end)

addHook("PreThinkFrame", function()
    for player in players.iterate do
        pbtDaemonmmt(player)
    end
end)

--!! L_ringattraction-v1.lua !! --

--[[
    Classic Ring Attraction script by Golden.
    Modified for MMT by EeveeEuphoria.
    Replicates how rings attract to the player in Sonic 3 and Sonic Mania.

    Lua people:
        To make your object also be effected by this script,
        just hook it into MobjThinker with the function A_ClassicRingAttract like so:

        addHook("MobjThinker", A_ClassicRingAttract, MT_CYBRAKDEMON)
]]

-- A list of objects to hook immediately during load.
local objects = {MT_RING, MT_FLINGRING, MT_COIN, MT_FLINGCOIN}

-- Change an object's type without deleting it.
-- Not globalising because I don't want to cause
-- people to actually use this.
local function changeObjectType(mo, newType)
    mo.type = newType

    local info = mobjinfo[newType]

    -- Set several mobj variables to their new defaults.
    mo.health = info.spawnhealth
    mo.reactiontime = info.reactiontime
    mo.radius = info.radius
    mo.height = info.height
    mo.flags = info.flags
end

-- Apply ring momentum for ring attraction.
-- [12:40 AM] MT_FLAME: ["mom" .. dimension] is extremely crafty
local function doRingMomentum(mo, dimension)
    -- where dimension == "x"
    -- mo[dimension] == mo.x
    -- mo["mom" .. dimension] == mo.momx

    local followmo = mo.followmo

    -- When moving toward player, accelerate fast
    -- When moving away from player, accelerate slow
    -- Always try to go towards player.

    if followmo[dimension] > mo[dimension] then
        if mo["mom" .. dimension] > followmo["mom" .. dimension] then
            mo["mom" .. dimension] = $ + FRACUNIT
        else
            mo["mom" .. dimension] = $ + FRACUNIT*2
        end
    elseif followmo[dimension] < mo[dimension] then
        if mo["mom" .. dimension] < followmo["mom" .. dimension] then
            mo["mom" .. dimension] = $ - FRACUNIT
        else
            mo["mom" .. dimension] = $ - FRACUNIT*2
        end
    end
end

-- Perform classic ring attraction. And many checks. Soo many checks.
function A_ClassicRingAttract(mo)
    -- Don't attract the rancid decomposing dead rings!
    if mo.health == 0 then
        mo.followmo = nil
        return
    end

    -- Check if player exists and is in range, and if so, link them to us.
    -- Otherwise, don't continue.
    if not mo.followmo or not mo.followmo.valid
    or not mo.followmo.player or not mo.followmo.player.valid then
        local target = mo.target -- Get current target, cause P_SupermanLook4Players overwrites it.
        local success = P_SupermanLook4Players(mo, 0, true)
        if success then
            if P_AproxDistance(P_AproxDistance(mo.x-mo.target.x, mo.y-mo.target.y), mo.z-mo.target.z) > RING_DIST
            or not ((mo.target.player.powers[pw_shield] & SH_PROTECTELECTRIC)) -- this is needed because if we don't do this, then rings on moving platforms get messed up
            then
                mo.target = target
                return
            end
            mo.followmo = mo.target
            mo.target = target
        else
            return
        end
    end

    local followmo = mo.followmo

    -- If the player doesn't have electrical protection, fling off!
    if (not (followmo.player.powers[pw_shield] & SH_PROTECTELECTRIC)) or not followmo.player.mmtSettings.cra then
        mo.flags = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_NOGRAVITY
        mo.followmo = nil

        if mo.attractive then -- But only if we're too good for them.
            if mo.type == MT_RING then
                changeObjectType(mo, MT_FLINGRING)
                mo.fuse = 8*TICRATE
            end
            mo.attractive = false -- Someone forgot to put on makeup...
        end

        return
    else
        mo.attractive = true -- We're beautiful
    end

    mo.fuse = 0 -- Never disappear

    mo.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOGRAVITY -- Go through everything

    -- Do the actual movement
    doRingMomentum(mo, "x")
    doRingMomentum(mo, "y")
    doRingMomentum(mo, "z")

    mo.state = mo.state -- Update state

    P_MoveOrigin(mo, mo.x + mo.momx, mo.y + mo.momy, mo.z + mo.momz) -- Update position using momentum.

    return true -- Skip ring thinker.
end

-- For each object type in objects, hook A_ClassicRingAttract to their thinker.
-- Yes, this is valid Lua code.
for i, v in ipairs(objects) do
    addHook("MobjThinker", A_ClassicRingAttract, v)
end

--[[
* l_fontlib.lua
* (sprkizard), (modified by EeveeEuphoria, to support ring racers, add support SOC colors, and add alpha)
* (Dec 6, 2021 16:51), (Jun 14, 2024 01:51)
* Desc: A custom drawstring function that can
        use custom font sets

* Usage: TODO
]]

rawset(_G, "Fontlib", {})

Fontlib.defaultspace = 4
Fontlib.defaultreturn = 4

Fontlib.fontinfo = {
    ["CRFNT"] = {upperonly=true},
    ["LTFNT"] = {},
    --["NTFNO"] = {},
    --["NTFNT"] = {upperonly=true},
    ["STCFN"] = {spacewidth=4, returnheight=4},
    ["TNYFN"] = {spacewidth=2, returnheight=5},
    ["MKFNT"] = {spacewidth=4, upperonly=true},
    ["FILE"] = {upperonly=true},
    ["CRFNT"] = {upperonly=true},
    ["GAMEM"] = {},
    ["MNUFN"] = {},
}

-- Creates an entry for custom font info (width between letters, return spacing, etc)
function Fontlib.setFontAttr(font, t)
    t = t or {} -- done to allow for laziness
    Fontlib.fontinfo[font] = {}
    for k,v in pairs(t) do
        Fontlib.fontinfo[font][k] = v
    end
end

-- Checks if the fontinfo entry exists, and gets the supplied attribute of it
function Fontlib.getFontAttr(font, attr)
    return (Fontlib.fontinfo[font] and Fontlib.fontinfo[font][attr])
end

-- Wrapper for validating table contents used here, and using them
function Fontlib.getAttr(t, key, attr)
    return (t[key] and t[key][attr])
end

-- Returns the width what the string as patches would be,
-- and returns all cached patches in a table
-- function Fontlib.GetInternalFontWidth(str, font)
function Fontlib.cachePatchWidth(v, str, font, space)

    -- No string
    if not (str) then return 0 end

    local patches = {}
    local width = 0

    for i=1,#str do

        local char = str:sub(i,i)

        -- Spaces before fonts. Use accurate font space widths or revert to defaults
        if char:byte() == 32 then
            width = $1 + (Fontlib.getFontAttr(font, "spacewidth") or 4)
            continue
        end
        -- Ignore skincolors completely
        if char:byte() >= 128 and char:byte() <= 199 then
            continue
        end
        -- TODO: count special characters?
        if char:byte() >= 200 and char:byte() <= 203 then
            -- width = $1+8
            continue
        end

        -- Create patch name format
        local patchname = string.format("%s%03d", font, char:byte())

        -- TODO: some patches do not exist, and the fix below may not be enough
        if not (v.patchExists(patchname)) then patches[char:byte()] = nil continue end

        -- Cache patches assigned by byte number
        if not (patches[char:byte()]) then
            -- Avoid caching the same character twice
            patches[char:byte()] = v.cachePatch( patchname )
        end
        width = $1 + (patches[char:byte()].width or 8) + space

    end
    return {patches=patches, linewidth=width}
end

function Fontlib.invalidCharPatch(patchlist, char)
    return patchlist[char:byte()] == nil and true or false
end

-- TODO: separate text effects
-- function Fontlib.stringEffects(x, y, char, time)
-- end

-- TODO: Find a way to capture embedded flags
-- (eg. Font swapping with format: t[font..char:byte()] to cache multiple characters))
--[[function Fontlib.gettextflag()
    local keypos = 0
    local ahead = 0

    if keypos and (pos >= keypos and pos <= ahead) then return end
    if line:sub(pos, pos+5) == "<test:" then

        keypos = pos
        ahead = pos+6

        local capture = ""

        for j=ahead, #line do
            if (line:sub(j, j) == ">") ahead = $1+#capture break end
            capture = $1 .. line:sub(j, j)
            -- print(keypos.."|"..str:sub(j, j))
        end
        x = capture
        return
    end
end--]]


function Fontlib.drawString(v, sx, sy, text, flags, align)

    -- Font Options
    local font = (flags and flags.font) or "STCFN"
    local uppercs = (flags and flags.upper) or false
    local ramp = (flags and flags.ramp) or nil -- Custom rainbow color
    local marspeed = (flags and flags.marspeed) or 4 -- Rainbow marquee speed
    local alpha = (flags and flags.alpha and flags.alpha<<V_ALPHASHIFT) or 0
    local color = nil

    -- Constants
    local spacewidth = (Fontlib.getFontAttr(font, "spacewidth") or 4)

    -- Scale adjustments
    local scale = (flags and flags.scale) or FRACUNIT
    local hscale = (flags and flags.hscale) or 0
    local vscale = (flags and flags.vscale) or 0

    -- Spacing
    local xspace = (flags and flags.xspace) or 0
    local yspace = (flags and flags.yspace) or (Fontlib.getFontAttr(font, "returnheight") or 4)

    -- Color equivalents to classic SOC colors
    local colorswap = (flags and flags.soccolors) or {SKINCOLOR_LAVENDER, SKINCOLOR_YELLOW, SKINCOLOR_GREEN, SKINCOLOR_BLUE, SKINCOLOR_RED, SKINCOLOR_GREY, SKINCOLOR_ORANGE, SKINCOLOR_CYAN, SKINCOLOR_PURPLE, SKINCOLOR_NOBLE, SKINCOLOR_GALAXY, SKINCOLOR_MAGENTA, SKINCOLOR_ROSY, SKINCOLOR_BROWN, SKINCOLOR_SIBERITE}

    -- Extra flags, useful for snap to top or bottom
    local extraflags = (flags and flags.extraflags) or 0

    -- Split our string into new lines from line-breaks
    local lines = {}

    for breaks in text:gmatch("[^\r\n]+") do
        table.insert(lines, breaks)
    end

    -- Interate through the text blocks (alignment should always go last before char drawing)
    for seg=1,#lines do

        local line = lines[seg]

        -- Screen x and y positions
        local x = sx
        local y = sy

        -- Text effects
        local off_x = 0
        local off_y = 0
        local swirl = 0
        local shake = 0
        local rainbow = 0
        local rcolors = ramp or {SKINCOLOR_RUBY, SKINCOLOR_ORANGE, SKINCOLOR_YELLOW, SKINCOLOR_MINT, SKINCOLOR_AQUAMARINE, SKINCOLOR_PASTEL, SKINCOLOR_ROSY}

        -- Current (+backwards) character & font patch (hopeful optimization)
        local bchar
        local char
        local charpatch

        -- Fixed is no longer an alignment option, and is now a flag
        if not (flags and flags.fixed) then
            x = $1 << FRACBITS
            y = $1 << FRACBITS
        end

        -- V_ALLOWLOWERCASE flag replacement
        if (uppercs or Fontlib.getFontAttr(font, "upperonly")) then
            line = tostring(line):upper()
        end

        -- Get used character patches and the width of the line
        -- TODO: character spacing does not work correctly
        local cache = Fontlib.cachePatchWidth(v, line, font, xspace)

        -- Text block alignment settings
        if (align == "center") then
            x = $1-FixedMul( cache.linewidth/2, scale) << FRACBITS
        elseif (align == "right") then
            x = $1-FixedMul( cache.linewidth, scale) << FRACBITS
        end


        -- v.drawString(320/2, 150+seg*8, "Line Length: "+#line, 0, "thin")
        for pos=1,#line do
            (function()

                -- String sub each character
                char = line:sub(pos, pos)

                -- Text Effects
                -- TODO: separate text effects
                -- ========
                -- Text Effect: Rainbow color
                if (char:byte() == 199) then
                    color = nil
                    rainbow = leveltime/marspeed + #line
                    return
                end

                -- Text Effect: Text color (Custom skincolors unsupported, only MAXSKINCOLORS allowed.)
                if (char:byte() == 128) or (char:byte() == 144) then
                    color = nil
                    rainbow = 0
                    return
                elseif (char:byte() >= 129 and char:byte() <= 143) then
                    color = v.getColormap(TC_DEFAULT, colorswap[char:byte() - 128])
                    rainbow = 0
                    return
                elseif (char:byte() >= 145 and char:byte() <= 198) then
                    color = v.getColormap(TC_DEFAULT, char:byte() - 144)
                    rainbow = 0
                    return
                end

                -- Stop effects
                if (char:byte() == 200) then
                    swirl = 0
                    shake = 0
                    off_x = 0
                    off_y = 0
                    return
                end

                -- Text Effect: That one undertale groove effect
                if (char:byte() == 201) then
                    swirl = leveltime*2
                    shake = 0
                    return
                end

                -- Text Effect: That one deltarune shake effect
                if (char:byte() == 202) then
                    shake = (leveltime/1)*(leveltime/1)*3
                    swirl = 0
                    return
                end

                if (rainbow) then
                    color = v.getColormap(TC_DEFAULT, rcolors[((rainbow-pos) % #rcolors)+1])
                end

                if (swirl) then
                    swirl = $1+2
                    off_x = (cos(ANG10*(swirl)))
                    off_y = (sin(ANG10*(swirl)))
                end

                if (shake) then
                    shake = ($1+1)*($1+FRACUNIT)
                    off_x = (cos(ANG10*shake))
                    shake = ($1+1)*($1+FRACUNIT)
                    off_y = (sin(ANG10*shake))
                end
                -- ========

                -- Prevent spaces and non-existent characters from drawing altogether
                if not char:byte() or char:byte() == 32 then
                    x = $1+spacewidth*scale
                    return
                end

                -- Weird return spacing fix by getting the previous character
                bchar = line:sub(pos-1, pos)

                -- If a character has no patch: prevent from drawing
                if (Fontlib.invalidCharPatch(cache.patches, char)) then return end

                -- Draw the current character given
                v.drawStretched(x+off_x, y+off_y, scale+hscale, scale+vscale, cache.patches[char:byte()], alpha|extraflags, color or v.getColormap(TC_DEFAULT, 1))

                -- Sets the space between each character using the font's width
                x = $1 + (xspace+cache.patches[char:byte()].width)*scale

            end)()
        end
        -- For control code effects, try to get the last character height
        local cheight = Fontlib.getAttr(cache.patches, char:byte(), "height")
        local bcheight = bchar and Fontlib.getAttr(cache.patches, bchar:byte(), "height") -- for some reason, bchar can sometimes be nil, and that causes problems.
        -- Break new lines by spacing and patch height for source-accurate spacing
        local linespacing = FixedMul( (yspace + (cheight or bcheight or 4) )*FRACUNIT, scale )
        sy = $1 + ((flags and flags.fixed) and linespacing or linespacing >> FRACBITS)

    end
end

local Font1 = "KHFNT"
local Font2 = "KHMNT"

Fontlib.setFontAttr(Font1, {spacewidth=2}) -- font i made :)
Fontlib.setFontAttr(Font2, {spacewidth=3}) -- the Nixdorf 8810 M15 font


-- !! jumpleniencymmt.lua !! --
-- this hasn't been modified to preserve compatibility w/ other mods that check for this mod, outside of the check MMT previously had

local function PreThinkJump(player)
    P_DoJump(player, true)

    -- Prevent using abilities immediately, by removing jump inputs.
    player.cmd.buttons = $1 | BT_JUMP
    player.pflags = $1 | PF_JUMPDOWN
end

local function RestoreAbility(player)
    player.secondjump = 0
    player.pflags = $1 & ~PF_THOKKED
end

local function RemoveAbility(player)
    player.secondjump = UINT8_MAX
    player.pflags = $1 | PF_THOKKED
end

local function JumpLeniencyThink(player)
    if not (player.mo and player.mo.valid) then
        return
    end
    local mo = player.mo

    local latency = 0 -- Default to 0 for EXEs without cmd.latency.
    pcall(function()
        latency = player.cmd.latency
    end)

    -- Init variables
    if (mo.coyoteTime == nil) then
        mo.coyoteTime = 0
    end

    if (mo.recoveryWait == nil) then
        mo.recoveryWait = 0
    end

    if (player.exiting) then
        -- Can't control anyway, don't need to do this.
        return
    end

    local pressedJump = false
    if (player.cmd.buttons & BT_JUMP) and not (player.pflags & PF_JUMPDOWN) then
        pressedJump = true
    end

    if (P_PlayerInPain(player) == true) then
        mo.coyoteTime = 0 -- Reset coyote time
        mo.recoveryWait = $1 + 1 -- Increment recovery wait time.

        -- The recovery jump from SA2, where you can jump out of your pain state.
        if (pressedJump == true) and (player.mmtSettings and player.mmtSettings.recovery) then
            local baseRecoveryWait = (2*TICRATE)/3 -- 0.667 seconds of waiting, - your latency.

            if (mo.recoveryWait > baseRecoveryWait - latency)
                PreThinkJump(player)

                --[[
                RemoveAbility(player)

                -- Reset momentum so you can move a bit.
                player.mo.momx = 0
                player.mo.momy = 0
                --]]

                RestoreAbility(player)
            end
        end

        -- Don't do any of the coyote time thinking.
        return
    end

    -- Reset recovery wait time outside of pain state.
    mo.recoveryWait = 0

    -- "Coyote time" is how much time you have after leaving the ground where you can jump off.
    -- Many modern platformers do this, especially 3D.
    -- Prevents lots of "the jump didn't jump".
    local baseCoyoteTime = TICRATE/4 -- 0.25 seconds, + your latency.

    -- Check if you're in a state where you would normally be allowed to jump.
    local canJump = false
    if ((P_IsObjectOnGround(mo) == true) or (P_InQuicksand(mo) == true))
    and (player.powers[pw_carry] == CR_NONE) then
        canJump = true
    end

    if (player.pflags & PF_JUMPED) then
        -- We jumped. We should not have coyote time.
        mo.coyoteTime = 0
    elseif (canJump == true) then
        -- Set the coyote time while in a state where you can jump.
        mo.coyoteTime = baseCoyoteTime + latency
    else
        if (pressedJump == true) and (mo.coyoteTime > 0) and (player.mmtSettings and player.mmtSettings.coyote)
        and (player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_IDLE) then -- just to ensure nothing funky happens in regards to springs, amy's hammer, etc.
            -- Pressed jump in a state where you can't jump,
            -- but you have coyote time. So we'll give you a jump anyway!
            PreThinkJump(player)
            RestoreAbility(player)
            mo.coyoteTime = 0
        end

        if (mo.coyoteTime > 0) then
            -- Reduce coyote timer while in a state where you can't jump.
            mo.coyoteTime = $1 - 1
        end
    end
end

addHook("PreThinkFrame", function()
    for player in players.iterate do
        JumpLeniencyThink(player)
    end
end)

-- !! Total Ring Count, taken from some ancient version of MMT !! --

local stagerings = 0
local stageringscollected = 0

addHook("MapChange", do
    stagerings = 0
    stageringscollected = 0
end)


addHook("MobjSpawn", function(mobj)
    stagerings = $ + 1
end, MT_RING)

addHook("MobjSpawn", function(mobj)
    stagerings = $ + 1
end, MT_COIN)

addHook("MobjSpawn", function(mobj)
    stagerings = $ + 10
end, MT_RING_BOX)


addHook("MobjDeath", function(mobj)
    stageringscollected = $ + 1
end, MT_RING)

addHook("MobjDeath", function(mobj)
    stageringscollected = $ + 1
end, MT_COIN)

addHook("MobjDeath", function(mobj)
    stageringscollected = $ + 10
end, MT_RING_BOX)

local function countrings(v, player)
    local vlayer = player
    if not vlayer
        vlayer = displayplayer -- just because the scores function doesn't allow for player for some reason >:(
    end
    local yringoffset = 0
    local xringoffset = 0
    local xringoffset2 = 0
    if vlayer.mo and vlayer.mo.valid and vlayer and vlayer.valid
    and (vlayer.mmtSettings.ringcount) and G_PlatformGametype() and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not G_IsSpecialStage(gamemap)
    and stagerings > 0
        if modifiedgame
        yringoffset = $ - 32
        end

        if vlayer.rings < 10
        elseif vlayer.rings >= 10 and vlayer.rings < 100
            xringoffset = $ + 8
        elseif vlayer.rings >= 100 and vlayer.rings < 1000
            xringoffset = $ + 16
        elseif vlayer.rings >= 1000
            xringoffset = $ + 24
        end

        if stagerings < 10
        elseif stagerings >= 10 and stagerings < 100
            xringoffset2 = $ + 8
        elseif stagerings >= 100 and stagerings < 1000
            xringoffset2 = $ + 16
        elseif stagerings >= 1000
            xringoffset2 = $ + 24
        end

        if not v.Timer
            v.Timer = 0
        end
        v.Timer = $ + 1

        if v.Timer > 23
            v.Timer = 0
        end

        local RingSprite, Flipper = v.getSpritePatch("RING", v.Timer)
        if Flipper == true
            v.FLIPFLAG = V_FLIP
        else
            v.FLIPFLAG = nil
        end

        local ColorMap

        if not multiplayer and vlayer.rings >= stagerings
            ColorMap = V_GREENMAP|V_PERPLAYER
        elseif not multiplayer and stageringscollected > vlayer.rings
            ColorMap = V_REDMAP|V_PERPLAYER
        else
            ColorMap = V_PERPLAYER
        end

        v.drawScaled(147*FRACUNIT, (171+yringoffset)*FRACUNIT, FRACUNIT/2, RingSprite, v.FLIPFLAG) -- X value used to be 151
        v.drawString(161, 160+yringoffset, "-", V_ALLOWLOWERCASE, left)

        v.drawString(172, 160+yringoffset, vlayer.rings, ColorMap)
        v.drawString(180+xringoffset, 160+yringoffset, "/", ColorMap)
        v.drawString(188+xringoffset, 160+yringoffset, stagerings, ColorMap)
        if not multiplayer and vlayer.rings!= stageringscollected
            if ColorMap == V_REDMAP|V_PERPLAYER
                v.AddOrMinus = ""
            else
                ColorMap = V_GREENMAP|V_PERPLAYER
                v.AddOrMinus = "+"
            end
            v.drawString(198+(xringoffset+xringoffset2), 160+yringoffset, "(" .. v.AddOrMinus .. vlayer.rings - stageringscollected .. ")", ColorMap)
        end
    end
end

hud.add(countrings, "scores")

-- !! VL_spring_twirl-v1.lua !! --

local function spring_twirl(mo)
    --assign player to a variable to make our lives a little bit easier (and our code a little bit readable)
    local player = mo.player
    if not player or not player.mmtSettings or not player.mmtSettings.springtwirl then return end
    --is player.twirl_angle assigned? if not, create it.
    if player.twirl_angle == nil then
        player.spring_twirl = false
        player.twirl_angle = 0	--starts at 0
    end
    --clear the spring twirl flag when we are at 0 momz
    if mo.momz == 0 and player.spring_twirl == true then
        player.spring_twirl = false
        player.steam = false
    end
    --are we currently in the spring animation?
    if (player.panim == PA_SPRING or player.steam) and player.spring_twirl == true then
        --add to our twirl angle
        player.twirl_angle = player.twirl_angle + FixedAngle(mo.momz)
        --make our draw angle twirl angle, therefore showing us spinning when we hit a spring
        player.drawangle = player.twirl_angle
    end
end

local function vertical_spring(thing, toucher)
    --is our toucher a player?
    if toucher.type == MT_PLAYER then
        if not toucher.player or not toucher.player.mmtSettings or not toucher.player.mmtSettings.springtwirl then return end
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            --height checks
            if toucher.player.mmtSettings.springtwirl then
                --set spring twirl to true
                toucher.player.spring_twirl = true
                toucher.player.twirl_angle = toucher.angle
            end
            if states[thing.state].frame == 0 and ((toucher.player.mmtSettings.sprsfx) or (toucher.player.mmtSettings.mmtsfxset)) then
                local sounder = toucher.player.mmtSettings.sprsfx
                if toucher.player.mmtSettings.mmtsfxset then
                    sounder = toucher.player.mmtSettings.mmtsfxset
                end
                if MMT.SpringTable[sounder] and sounder and not S_SoundPlaying(thing, MMT.SpringTable[sounder]) then
                    S_StartSound(toucher.player.realmo, MMT.SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
    end
end

local function stopsoundthing(spring)
    if spring.stopsound == nil then
        spring.stopsound = 0
    end
    if spring.stopsound > 0 then
        S_StopSoundByID(spring, sfx_spring)
        spring.stopsound = $ + 1
        if spring.stopsound > 8 then
            spring.stopsound = 0
        end
    end
end

local function diagonal_spring(thing, toucher)
    if toucher.type == MT_PLAYER then
        if not toucher.player or not toucher.player.mmtSettings or not toucher.player.mmtSettings.springtwirl then return end
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            --height checks
            if toucher.player.mmtSettings.springtwirl then
                --set spring twirl to false
                --this is only so that if we go from a vertical spring to a diagonal one, we don't twirl again
                --we don't have to do this for the horziontal springs since they don't put you into your spring animation
                toucher.player.spring_twirl = false
            end
            if states[thing.state].frame == 0 and ((toucher.player.mmtSettings.sprsfx) or (toucher.player.mmtSettings.mmtsfxset)) then
                local sounder = toucher.player.mmtSettings.sprsfx
                if toucher.player.mmtSettings.mmtsfxset then
                    sounder = toucher.player.mmtSettings.mmtsfxset
                end
                if MMT.SpringTable[sounder] and sounder and not S_SoundPlaying(thing, MMT.SpringTable[sounder]) then
                    S_StartSound(toucher.player.realmo, MMT.SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
    end
end

local function horziontal_spring(thing, toucher)
    if toucher.type == MT_PLAYER then
        if not toucher.player or not toucher.player.mmtSettings or not toucher.player.mmtSettings.springtwirl then return end
        if toucher.z + toucher.height > thing.z and toucher.z < thing.z + thing.height + 4*FRACUNIT then
            if states[thing.state].frame == 0 and ((toucher.player.mmtSettings.sprsfx) or (toucher.player.mmtSettings.mmtsfxset)) then
                local sounder = toucher.player.mmtSettings.sprsfx
                if toucher.player.mmtSettings.mmtsfxset then
                    sounder = toucher.player.mmtSettings.mmtsfxset
                end
                if MMT.SpringTable[sounder] and sounder and not S_SoundPlaying(thing, MMT.SpringTable[sounder]) then
                    S_StartSound(toucher.player.realmo, MMT.SpringTable[sounder])
                    thing.stopsound = 1
                end
            end
        end
    end
end

addHook("MobjThinker", spring_twirl, MT_PLAYER)

addHook("MobjCollide", vertical_spring, MT_REDSPRING)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRING)
addHook("MobjCollide", vertical_spring, MT_BLUESPRING)
addHook("MobjCollide", vertical_spring, MT_SPRINGSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSHELL)
addHook("MobjCollide", vertical_spring, MT_YELLOWSPRINGBALL)
addHook("MobjCollide", vertical_spring, MT_REDSPRINGBALL)

addHook("MobjCollide", diagonal_spring, MT_REDDIAG)
addHook("MobjCollide", diagonal_spring, MT_YELLOWDIAG)
addHook("MobjCollide", diagonal_spring, MT_BLUEDIAG)

addHook("MobjCollide", horziontal_spring, MT_REDHORIZ)
addHook("MobjCollide", horziontal_spring, MT_YELLOWHORIZ)
addHook("MobjCollide", horziontal_spring, MT_BLUEHORIZ)


addHook("MobjThinker", stopsoundthing, MT_REDSPRING)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSPRING)
addHook("MobjThinker", stopsoundthing, MT_BLUESPRING)
addHook("MobjThinker", stopsoundthing, MT_SPRINGSHELL)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSHELL)
addHook("MobjThinker", stopsoundthing, MT_YELLOWSPRINGBALL)
addHook("MobjThinker", stopsoundthing, MT_REDSPRINGBALL)
addHook("MobjThinker", stopsoundthing, MT_REDDIAG)
addHook("MobjThinker", stopsoundthing, MT_YELLOWDIAG)
addHook("MobjThinker", stopsoundthing, MT_BLUEDIAG)
addHook("MobjThinker", stopsoundthing, MT_REDHORIZ)
addHook("MobjThinker", stopsoundthing, MT_YELLOWHORIZ)
addHook("MobjThinker", stopsoundthing, MT_BLUEHORIZ)


addHook("MobjCollide", function(thing, tmthing) -- adding in the spring twirl for steam, because i said so bitch
    if tmthing and tmthing.player then
        local player = tmthing.player
        if not toucher or toucher.player or not toucher.player.mmtSettings or not toucher.player.mmtSettings.springtwirl then return end
        if player.mmtSettings.springtwirl then
            if thing.state == S_STEAM1 and abs(tmthing.z-thing.z) <= thing.height then
                player.spring_twirl = true
                player.twirl_angle = tmthing.angle
                player.steam = true -- turns out this is unnessecary now, but i'm leaving it in
                player.mo.state = S_PLAY_SPRING
                return true -- this causes this to run multiple times, but that's okay, it forces the player into the spring state and not much else
            end
        end
    end
end, MT_STEAM, MT_PLAYER)


-- !! Classic Shields !! --

local function ChangeShield(classicshield) -- TODO: make this detect if the monitor is in water somehow. maybe use watertop?
    if MMT.mmtGlobalSet.classicshield then
        classicshield.prevname = classicshield.type
        if classicshield.type == MT_ATTRACT_BOX then
            classicshield.type = MT_THUNDERCOIN_BOX
        elseif classicshield.type == MT_ATTRACT_GOLDBOX then
            classicshield.type = MT_THUNDERCOIN_GOLDBOX

        elseif classicshield.type == MT_FORCE_BOX then
            classicshield.type = MT_BUBBLEWRAP_BOX
        elseif classicshield.type == MT_FORCE_GOLDBOX then
            classicshield.type = MT_BUBBLEWRAP_GOLDBOX

        elseif classicshield.type == MT_WHIRLWIND_BOX then
            classicshield.type = MT_THUNDERCOIN_BOX
        elseif classicshield.type == MT_WHIRLWIND_GOLDBOX then
            classicshield.type = MT_THUNDERCOIN_GOLDBOX

        elseif classicshield.type == MT_ARMAGEDDON_BOX then
            classicshield.type = MT_FLAMEAURA_BOX
        elseif classicshield.type == MT_ARMAGEDDON_GOLDBOX then
            classicshield.type = MT_FLAMEAURA_GOLDBOX

        elseif (classicshield.type == MT_ELEMENTAL_BOX or classicshield.type == MT_ELEMENTAL_GOLDBOX) then
            if classicshield.watertop != classicshield.z - 1000*FRACUNIT and classicshield.waterbottom != classicshield.z - 1000*FRACUNIT then -- this is a good way to detect if the object is in water
                classicshield.ChangeType = MT_BUBBLEWRAP_BOX
            elseif mapheaderinfo[gamemap].lvlttl == "Red Volcano" then
                classicshield.ChangeType = MT_FLAMEAURA_BOX
            else
                if P_RandomByte() < 127 then
                    classicshield.ChangeType = MT_BUBBLEWRAP_BOX
                else
                    classicshield.ChangeType = MT_FLAMEAURA_BOX
                end
            end

            if classicshield.type == MT_ELEMENTAL_GOLDBOX
                if classicshield.ChangeType == MT_BUBBLEWRAP_BOX
                    classicshield.ChangeType = MT_BUBBLEWRAP_GOLDBOX
                else
                    classicshield.ChangeType = MT_FLAMEAURA_GOLDBOX
                end
            end
            classicshield.type = classicshield.ChangeType
        end
    end
end

local function OnMonitorHit(classicshield, inflictor, source)
    if classicshield.prevname != nil then
        if source then
            source.player.ShieldPrevname = classicshield.prevname
        end
    end
end

local function RevertClassicShieldFunc(classicshield)
    if not MMT.mmtGlobalSet.classicshield then
        if classicshield.prevname != nil
            classicshield.type = classicshield.prevname
        end
    end
end


addHook("MobjThinker", ChangeShield, MT_ATTRACT_BOX)
addHook("MobjThinker", ChangeShield, MT_ATTRACT_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_FORCE_BOX)
addHook("MobjThinker", ChangeShield, MT_FORCE_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_WHIRLWIND_BOX)
addHook("MobjThinker", ChangeShield, MT_WHIRLWIND_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_ARMAGEDDON_BOX)
addHook("MobjThinker", ChangeShield, MT_ARMAGEDDON_GOLDBOX)
addHook("MobjThinker", ChangeShield, MT_ELEMENTAL_BOX)
addHook("MobjThinker", ChangeShield, MT_ELEMENTAL_GOLDBOX)

addHook("MobjThinker", RevertClassicShieldFunc, MT_FLAMEAURA_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_BUBBLEWRAP_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_THUNDERCOIN_BOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_FLAMEAURA_GOLDBOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_BUBBLEWRAP_GOLDBOX)
addHook("MobjThinker", RevertClassicShieldFunc, MT_THUNDERCOIN_GOLDBOX)

addHook("MobjDeath", OnMonitorHit, MT_THUNDERCOIN_BOX)
addHook("MobjDeath", OnMonitorHit, MT_BUBBLEWRAP_BOX)
addHook("MobjDeath", OnMonitorHit, MT_FLAMEAURA_BOX)
addHook("MobjDeath", OnMonitorHit, MT_THUNDERCOIN_GOLDBOX)
addHook("MobjDeath", OnMonitorHit, MT_BUBBLEWRAP_GOLDBOX)
addHook("MobjDeath", OnMonitorHit, MT_FLAMEAURA_GOLDBOX)


-- !! deathscounter !! --

--[[ deaths counter.lua
Author: birbhorse, aka EeveeEuphoria
Modified for use in MMT Revamped.

replaces the lives counter with a death counter, while also giving the player infinite lives
does not apply to game modes where lives aren't applicable

]]--


-- [[ player logic ]] --

addHook("PlayerThink", function(player)
    if not G_GametypeUsesLives() then hud.enable("lives") return end
    if not player.DCMod return end
    if not player.DCMod.initialize return end
    if player.bot then return end
    if player.playerstate == PST_DEAD and not player.DCMod.timer and not G_IsSpecialStage(gamemap) and not player.DCMod.reverse
        player.DCMod.deaths = $ + 1
    end

    if player.playerstate == PST_DEAD and not player.DCMod.reverse
        player.DCMod.timer = $ + 1
        player.DCMod.Died = true
    end


    if player.DCMod.reverse
        if player.playerstate != PST_DEAD
            player.DCMod.timer2 = $ + 1
            if player.DCMod.timer2 > TICRATE*2
                if player.DCMod.timer < TICRATE
                    player.DCMod.timer = $ + 1
                else
                    player.DCMod.reverse = false
                    player.DCMod.timer = 0
                end
            end
        else
            player.DCMod.reverse = false
            player.DCMod.timer = 0
        end
    end

    if (player.pflags & PF_FINISHED) or stoppedclock
        player.DCMod.timer = $ + 1
    end
end)


addHook("PlayerThink", function(player) -- replaced player spawn with a thinker, just so it can run after mmt
    if not G_GametypeUsesLives() then return end
    if player.bot then return end

    if player.mmt then
        if player.lives != INFLIVES then
            player.DCMod.PreviousLives = player.lives
        end

        if player.mmtSettings.deathscounter then
            hud.disable("lives")
            player.lives = INFLIVES
        else
            if player.DCMod.liveshudenabled then
                hud.enable("lives")
            end
            if tonumber(player.DCMod.PreviousLives) and player.lives == INFLIVES then
                player.lives = player.DCMod.PreviousLives
            end
        end
    end
end)

addHook("PlayerSpawn", function(player)
    if player.bot then return end
    if not player.DCMod then
        player.DCMod = {}
        player.DCMod.deaths = 0
        player.DCMod.Died = true
        player.DCMod.CurrentLevel = gamemap
        player.DCMod.liveshudenabled = hud.enabled("lives")
    end

    if player.DCMod.CurrentLevel != gamemap then
        player.DCMod.CurrentLevel = gamemap
        if player.mmtSettings.deathscounter == 2 then
            player.DCMod.deaths = 0
        end
        player.DCMod.Died = true
    end

    if not player.DCMod.Died and not G_IsSpecialStage(gamemap) then -- detects if a player hit the "retry" button in single player
        player.DCMod.deaths = $ + 1
    else
        player.DCMod.Died = false
    end

    player.DCMod.timer = 0
    player.DCMod.timer2 = 0
    player.DCMod.reverse = true


    player.DCMod.initialize = true
end)

-- [[ hud logic ]] --

hud.add(function(v, player, cam) if not G_GametypeUsesLives() hud.enable("lives") return end if not player.DCMod then return end if player.DCMod.timer == nil then return end
    if player.bot return end
    if not (player.mo and player.mo.valid and player and player.valid) return end -- just for in case, srb2 can be weird about this
    if not player.mmtSettings.deathscounter then return end

    local XGoal = hudinfo[HUD_LIVES].x
    local YGoal = hudinfo[HUD_LIVES].y

    local function CheckPause() -- detect if game is paused, if so, halt all operations, unless the game is alt-tabbed for some fucking reason
        if menuactive and not netgame then return true end
        if paused then return true end
        --if focuslost return true end
        return false
    end

    v.TickDownValue = 20 -- after this amount of tics, assuming it's less than TICRATE, the sine formula will start to go in reverse, aka negative values
    v.TimerPlus = 65 -- additional value added to sinmath value, to increase the amount of time it's actually been since things started for that value alone

    if v.xoffset == nil
        v.xoffset = 0
        v.yoffset = YGoal*FRACUNIT
    end

    if player.MMTdcvis != "show" then
        if not CheckPause()
            if player.DCMod.timer == 0
                if player.DCMod.reverse
                    v.yoffset = YGoal*FRACUNIT
                else
                    v.yoffset = 200*FRACUNIT -- off-screen, hopefully
                end
            else
                if player.DCMod.reverse
                    if player.DCMod.timer <= TICRATE
                        v.tickerdown = 15 - player.DCMod.timer
                        v.SinMath = (FRACUNIT/3)*(player.DCMod.timer+(v.TimerPlus*2))
                        v.yoffset = $ - (v.tickerdown * 100)*sin(v.SinMath)
                    end
                else
                    if player.DCMod.timer <= TICRATE
                        v.tickerdown = v.TickDownValue - player.DCMod.timer
                        v.SinMath = (FRACUNIT)*(player.DCMod.timer+v.TimerPlus)
                        v.yoffset = $ - (v.tickerdown * 85)*sin(v.SinMath)
                        if player.DCMod.timer > v.TickDownValue then
                            if v.yoffset > YGoal*FRACUNIT
                                v.yoffset = YGoal*FRACUNIT
                            end
                        end
                    end
                end
            end
        end
    else
        v.yoffset = YGoal*FRACUNIT
    end
    local booblean = false
    if player.powers[pw_super] and player.mo.skin == "sonic" then --for some reason super icons are not defined by the lack of SF_NOSUPERSPRITES, so i don't fuckin know how to check if a character doesn't have a super icon. ergo... sonic gets special treatment. hope you're happy you gluttonous hedgehog.
        booblean = true
    end

    local lifeicon = v.getSprite2Patch(player.mo.skin, "XTRA", booblean, A)
    local colormap = v.getColormap(player.mo.skin, player.mo.color)
    local xicon = v.cachePatch("stlivex")

    v.drawScaled((XGoal+v.xoffset)*FRACUNIT, v.yoffset, FRACUNIT/2, lifeicon, V_SNAPTOLEFT|V_SNAPTOBOTTOM, colormap)  -- life icon
    v.drawScaled((XGoal+22+v.xoffset)*FRACUNIT, v.yoffset + (9*FRACUNIT), FRACUNIT, xicon, V_SNAPTOLEFT|V_SNAPTOBOTTOM)  -- "X"
    v.drawString((XGoal+18+v.xoffset), (v.yoffset/FRACUNIT) + 0, "DEATHS", V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_YELLOWMAP)  -- text
    v.drawString((XGoal+42+v.xoffset), (v.yoffset/FRACUNIT) + 8, player.DCMod.deaths, V_SNAPTOLEFT|V_SNAPTOBOTTOM) -- number

end, "game")

local function AlwaysOnDeathsCounter(v, player, cam) if not player then player = displayplayer end
    if not G_GametypeUsesLives() then hud.enable("lives") return end
    if not player.DCMod then return end if player.DCMod.timer == nil then return end if player.bot then return end
    if not (player.mo and player.mo.valid and player and player.valid) then return end -- just for in case, srb2 can be weird about this
    if not player.mmtSettings.deathscounter then return end
    if player.MMTdcvis == "on" then return end

    if player.DCMod.timer2 < TICRATE*3 then return end


    local XGoal = hudinfo[HUD_LIVES].x
    local YGoal = hudinfo[HUD_LIVES].y

    if v.xxoffset == nil
        v.xxoffset = 0
        v.yyoffset = YGoal*FRACUNIT
    end

    v.yyoffset = YGoal*FRACUNIT

    local lifeicon = v.getSprite2Patch(player.mo.skin, "XTRA", A)
    local colormap = v.getColormap(player.mo.skin, player.mo.color)
    local xicon = v.cachePatch("stlivex")

    v.drawScaled((XGoal+v.xxoffset)*FRACUNIT, v.yyoffset, FRACUNIT/2, lifeicon, V_SNAPTOLEFT|V_SNAPTOBOTTOM, colormap)  -- life icon
    v.drawScaled((XGoal+22+v.xxoffset)*FRACUNIT, v.yyoffset + (9*FRACUNIT), FRACUNIT, xicon, V_SNAPTOLEFT|V_SNAPTOBOTTOM)  -- "X"
    v.drawString((XGoal+18+v.xxoffset), (v.yyoffset/FRACUNIT) + 0, "DEATHS", V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_YELLOWMAP)  -- text
    v.drawString((XGoal+42+v.xxoffset), (v.yyoffset/FRACUNIT) + 8, player.DCMod.deaths, V_SNAPTOLEFT|V_SNAPTOBOTTOM) -- number
end

hud.add(AlwaysOnDeathsCounter, "scores")
--hud.add(AlwaysOnDeathsCounter, "intermission") -- doesn't actually appear?

-- !! SFX Style !! --
-- Code is somewhat derived from the "Personal Sounds" mod.

MMT.addTweak{name = "Jump SFX", intname = "jsfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 7}, names = {"off", "Sonic 1", "Sonic 2", "Sonic CD", "Sonic 3K", "Knuckles' Chaotix", "NiGHTs", "Super Mario Bros."},
descriptiont = {"The player's jump sound"}
}

local JumpTable = {
    [1] = sfx_s1a0,
    [2] = sfx_s220,
    [3] = sfx_cdfm02,
    [4] = sfx_s3k62,
    [5] = sfx_cdfm02,
    [6] = sfx_ngjump,
    [7] = sfx_mario6,
}

MMT.addTweak{name = "Skidding SFX", intname = "sksfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 5}, names = {"off", "Sonic 1", "Sonic 2", "Sonic 3K", "Sonic CD", "Knuckles' Chaotix"},
descriptiont = {"Stopping in place sound"}
}

local SkiddingTable = {
    [1] = sfx_s1a4,
    [2] = sfx_s224,
    [3] = sfx_s3k36,
    [4] = sfx_cdfm00,
    [5] = sfx_kc2b,
}

local PutPutTable = {
    ["Sonic 3K"] = sfx_s3kba,
}
local PudPudTable = {
    ["Sonic 3K"] = sfx_s3kbb,
}

local SpikesTable = {
    ["Sonic 1"] = sfx_s1a6,
    ["Sonic 2"] = sfx_s226,
    ["Sonic 3K"] = sfx_s3k37,
}

local DeathTable = { -- ominous name
    ["Sonic 1"] = sfx_s1a3,
    ["Sonic 2"] = sfx_s223,
    ["Sonic CD"] = sfx_cdfm03,
    ["Sonic 3K"] = sfx_s3k35,
    ["Knuckles' Chaotix"] = sfx_kc58,
}

MMT.addTweak{name = "Spinning SFX", intname = "spinsfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 4}, names = {"off", "Sonic 1", "Sonic 2", "Sonic 3K", "Sonic CD/Knuckles' Chaotix"},
descriptiont = {"Rolling into a ball sound"}
}

local SpinningTable = {
    [1] = sfx_s1be,
    [2] = sfx_s23e,
    [3] = sfx_s3k3c,
    [4] = sfx_cdfm12,
}

MMT.addTweak{name = "Spindash SFX", intname = "spdsfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 4}, names = {"off", "Sonic 2", "Sonic 3K", "Sonic CD", "Knuckles' Chaotix"},
descriptiont = {"Revving up a spindash sound"}
}

local SpindashTable = {
    [1] = sfx_s260,
    [2] = sfx_s3kab,
    [3] = sfx_cdfm11,
    [4] = sfx_kc6c,
}

MMT.addTweak{name = "Spindash Release SFX", intname = "spzsfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 4}, names = {"off", "Sonic 2", "Sonic 3K", "Sonic CD", "Knuckles' Chaotix"},
descriptiont = {"Letting that spindash go sound"}
}

local SpinzoomTable = {
    [1] = sfx_s23c,
    [2] = sfx_s3kb6,
    [3] = sfx_cdfm01,
    [4] = sfx_kc3c,
}

local GaspTable = {
    ["Sonic 1"] = sfx_s1ad,
    ["Sonic 2"] = sfx_s22d,
    ["Sonic CD"] = sfx_cdfm29,
    ["Sonic 3K"] = sfx_s3k38,
}

local DrownTable = {
    ["Sonic 1"] = sfx_s1b2,
    ["Sonic 2"] = sfx_s232,
    ["Sonic CD"] = sfx_cdfm38,
    ["Sonic 3K"] = sfx_s3k3b,
}

local AirTimerTable = { -- TODO: might be possible via S_StopSoundByID now? idk if that was added after i was complaining about S_StopSoundByNum not existing lol
    ["Sonic CD"] = sfx_cdfm49,
}

MMT.addTweak{name = "Spring SFX", intname = "sprsfx", menu = "sfxstyle", options = "number", default = 0, range = {0, 5}, names = {"off", "Sonic 1", "Sonic 2", "Sonic 3K", "Sonic CD", "Knuckles' Chaotix"},
descriptiont = {"Launching from a spring sound"}
}

MMT.SpringTable = {
    [1] = sfx_s1cc,
    [2] = sfx_s1cc,
    [3] = sfx_s3kb1,
    [4] = sfx_cdfm08,
    [5] = sfx_kc2f
}


local function ReplaceSound(mo, value, table, sound)
    local obj = mo
    if mo.player then
        obj = mo.player.realmo
    end
    if value
    and S_SoundPlaying(obj, sound)
    and table[value] then
        S_StopSoundByID(obj, sound)
        S_StartSound(obj, table[value])
    end
end

local function ReplaceSoundsFunctionTime(player)
    if not (player and player.valid) then return end -- Player must exist.
    if not (player == consoleplayer) then return end -- We only worry about ourselves!
    if not (player.realmo and player.realmo.valid) then return end -- Their object ALSO must exist.

    local JumpVal = player.mmtSettings.jsfx
    local SkiddingVal = player.mmtSettings.sksfx

    local TailsFlyVal = player.mmtSettings.flightsfx
    local DedVal = player.mmtSettings.dedsfx
    local SpikesVal = player.mmtSettings.spikesfx

    local SpinningVal = player.mmtSettings.spinsfx
    local SpindashVal = player.mmtSettings.spdsfx
    local SpinzoomVal = player.mmtSettings.spzsfx
    local DrowningVal = player.mmtSettings.drownsfx
    local GaspVal = player.mmtSettings.gaspsfx

    if player.mmtSettings.mmtsfxset then --TODO: this
        JumpVal = player.mmtSettings.mmtsfxset
        SkiddingVal = player.mmtSettings.mmtsfxset
        TailsFlyVal = player.mmtSettings.mmtsfxset
        DedVal = player.mmtSettings.mmtsfxset
        SpikesVal = player.mmtSettings.mmtsfxset

        SpinningVal = player.mmtSettings.mmtsfxset
        SpindashVal = player.mmtSettings.mmtsfxset
        SpinzoomVal = player.mmtSettings.mmtsfxset
        GaspVal = player.mmtSettings.mmtsfxset
        DrowningVal = player.mmtSettings.mmtsfxset
    end

    ReplaceSound(player.mo, JumpVal, JumpTable, sfx_jump)
    ReplaceSound(player.mo, SkiddingVal, SkiddingTable, sfx_skid)
    ReplaceSound(player.mo, TailsFlyVal, PutPutTable, sfx_putput)
    ReplaceSound(player.mo, TailsFlyVal, PudPudTable, sfx_pudpud)
    ReplaceSound(player.mo, SpikesVal, SpikesTable, sfx_spkdth)

    ReplaceSound(player.mo, SpinningVal, SpinningTable, sfx_spin)
    ReplaceSound(player.mo, SpindashVal, SpindashTable, sfx_spndsh)
    ReplaceSound(player.mo, SpinzoomVal, SpinzoomTable, sfx_zoom)
    ReplaceSound(player.mo, GaspVal, GaspTable, sfx_gasp)
    ReplaceSound(player.mo, DrowningVal, DrownTable, sfx_drown)


    if DedVal != "off" -- manually doing it for death because it's janky
    and (S_SoundPlaying(player.realmo, sfx_altdi1) or S_SoundPlaying(player.realmo, sfx_altdi2) or S_SoundPlaying(player.realmo, sfx_altdi3) or S_SoundPlaying(player.realmo, sfx_altdi4))
    and DeathTable[DedVal] then
        S_StopSoundByID(player.realmo, sfx_altdi1)
        S_StopSoundByID(player.realmo, sfx_altdi2)
        S_StopSoundByID(player.realmo, sfx_altdi3)
        S_StopSoundByID(player.realmo, sfx_altdi4)
        S_StartSound(player.realmo, DeathTable[DedVal])
    end
end

-- this is set up like this for in case i need to switch back to a playerthink function
-- if you're seeing this then i forgot to remove this text, and i didn't swap to a playerthink function
-- using postthinkframe is slightly better at cutting off sounds than the playerthink function, but might come at the cost of incompatibility with netgames, only time will tell

addHook("PostThinkFrame", function()
    for player in players.iterate do
        ReplaceSoundsFunctionTime(player)
        -- Classic Special Stage --
        if player.SSE then
            S_StopSoundByID(player.mo, sfx_token) -- disables the sound when leaving a stage
            player.mo.flags2 = $ | MF2_DONTDRAW
            if player.preserveshield == "off" or player.ShieldAlreadySaved then
                player.powers[pw_shield] = 0
            end
            player.powers[pw_invulnerability] = 0
            player.powers[pw_sneakers] = 0 -- solely because of pointy/fluffy
        end
    end
end)

-- !! Anglestand !! --
-- Anglestand / Angleability --
-- i ported this code almost directly from VL_anglestand-v1.5.1.lua, don't blame me for the indentation

addHook("FollowMobj", function(player, followMob)
    local mo = player.mo
    if(mo.state == S_PLAY_ANGLEIDLE) then
        local newAngle = player.drawangle
        if(newAngle != nil) then
            P_MoveOrigin(followMob, (mo.x - cos(newAngle)), (mo.y - sin(newAngle)), mo.z)
            followMob.angle = newAngle
            return true
        end
    end
end, MT_TAILSOVERLAY)

addHook("MobjThinker", function(mo)
    local player = mo.player
    if not player.mmtSettings then return end

        local delayer = player.idleDelay
        if not player.idleDelay then
            delayer = 3*TICRATE
        end
        if player.playerstate == PST_LIVE then
            if player and not player.mmtSettings.AngleStand then
                if mo.state == S_PLAY_ANGLEIDLE then
                    mo.state = S_PLAY_STND
                end
                return
            end

            -- prevents script from affecting strafe mode players
            -- only works in singleplayer
            if (player.mmtSettings.strafeAnglestand and (not (player.pflags & !PF_FORCESTRAFE))) then
                if (mo.state == S_PLAY_ANGLEIDLE) then
                    mo.state = S_PLAY_WAIT
                    player.idlewait = 0
                end
                return
            end

            -- If nonIdle is true, later code will know not to trigger an idle animation.
            local nonIdle = 0
            if (player.powers[pw_super] or player.hypermysticsonic) then
                nonIdle = 1
            end
            local initialState = mo.state
            local followMob = mo.followmobj
            if player.prevdrawangle then

                -- special code for telekinetic hedgehogs
                if (mo.skin == "silver")
                    if (mo.silv_telekinesis and #mo.silv_telekinesis)	-- Silver was, and might still be, holding something.
                        mo.wasTelekinesis = true
                        if (mo.silv_thrown and #mo.silv_thrown and not (#mo.silv_telekinesis > #mo.silv_thrown)) -- Silver isn't holding anything anymore.
                            player.idlewait = 0
                            mo.state = S_PLAY_STND
                            mo.wasTelekinesis = false
                        end
                    elseif (mo.wasTelekinesis == true) then	-- Silver was holding something, but isn't anymore.
                        player.idlewait = 0
                        mo.state = S_PLAY_STND
                        mo.wasTelekinesis = false
                    elseif (initialState == S_PLAY_WAIT) then	-- Silver is in his idle animation. Because he only uses 1 frame for himself, he doesn't need to be using the custom idle state.
                        player.drawangle = player.prevdrawangle
                        mo.state = S_PLAY_WAIT			-- As a matter of fact, the custom idle state breaks his idle animation.
                        player.idlewait = delayer
                    elseif (initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))) then

                        player.drawangle = player.prevdrawangle

                        -- initiates idle animation when the idlewait timer reaches its limit
                            if(player.idlewait != nil)
                                local idlewait = player.idlewait
                                if(idlewait < delayer) then
                                    player.idlewait = $ + 1
                                else
                                    if(idlewait < delayer + 1) then
                                        mo.state = S_PLAY_WAIT
                                    end
                                end

                            else
                                player.idlewait = 1
                            end
                    elseif
                    (
                        mo.momx == 0
                        and mo.momy == 0
                        and
                        (
                            initialState == S_PLAY_JUMP
                            or initialState == S_PLAY_EDGE
                            or initialState == S_PLAY_FALL
                            or initialState == S_PLAY_SPRING
                            or initialState == S_PLAY_GASP
                            or initialState == S_PLAY_FLOAT
                        )
                    ) then
                        player.drawangle = player.prevdrawangle
                        player.idlewait = 0

                    elseif (initialState == S_PLAY_ANGLEIDLE) then -- Fixes bug arising from swapping skins while in S_PLAY_ANGLEIDLE
                        mo.state = S_PLAY_STND
                        player.idlewait = delayer

                    -- resets idle timer
                    else
                        player.idlewait = 0
                    end
                    -- end of Silver's code

                -- special code for Dirk
                elseif(mo.skin == "dirk")
                    if(mo.dirk_idle >= 0)	-- Dirk is idling
                        player.drawangle = player.prevdrawangle
                        player.idlewait = delayer
                    elseif(initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART)))

                        player.drawangle = player.prevdrawangle

                        -- initiates idle animation when the idlewait timer reaches its limit
                            if(player.idlewait != nil)
                                local idlewait = player.idlewait
                                if(idlewait < delayer)
                                    player.idlewait = $ + 1
                                else
                                    if(idlewait < delayer + 1)
                                        mo.state = S_PLAY_WAIT
                                    end
                                end

                            else
                                player.idlewait = 1
                            end
                    elseif
                    (
                        mo.momx == 0
                        and mo.momy == 0
                        and
                        (
                            initialState == S_PLAY_JUMP
                            or initialState == S_PLAY_EDGE
                            or initialState == S_PLAY_FALL
                            or initialState == S_PLAY_SPRING
                            or initialState == S_PLAY_GASP
                            or initialState == S_PLAY_FLOAT
                        )
                    )
                        player.drawangle = player.prevdrawangle
                        player.idlewait = 0

                    elseif(initialState == S_PLAY_ANGLEIDLE) -- Fixes bug arising from swapping skins while in S_PLAY_ANGLEIDLE
                        mo.state = S_PLAY_WAIT
                        player.idlewait = delayer

                    -- resets idle timer
                    else
                        player.idlewait = 0
                    end
                -- end of Dirk's code

                -- For characters who shouldn't be going into an idle animation.
                elseif(nonIdle == 1)
                    if
                    (
                        initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))
                        or
                        (
                            mo.momx == 0
                            and mo.momy == 0
                            and
                            (
                                initialState == S_PLAY_JUMP
                                or initialState == S_PLAY_EDGE
                                or initialState == S_PLAY_FALL
                                or initialState == S_PLAY_SPRING
                                or initialState == S_PLAY_GASP
                                or initialState == S_PLAY_FLY
                                or initialState == S_PLAY_FLY_TIRED
                                or initialState == S_PLAY_GLIDE_LANDING
                                or initialState == S_PLAY_SWIM
                                or initialState == S_PLAY_TWINSPIN
                                or initialState == S_PLAY_BOUNCE
                                or initialState == S_PLAY_BOUNCE_LANDING
                                or initialState == S_PLAY_FLOAT
                            )
                        )
                    )
                        player.drawangle = player.prevdrawangle
                    end

                -- for everyone else
                -- swaps the default idle animation for the custom one, unless the skin is silver
                elseif (initialState == S_PLAY_WAIT) then
                    mo.state = S_PLAY_ANGLEIDLE
                    player.idlewait = delayer + 1

                elseif ((initialState == S_PLAY_STND and (not (player.powers[pw_carry] & CR_MINECART))) or initialState == S_PLAY_ANGLEIDLE)

                    player.drawangle = player.prevdrawangle

                    -- initiates idle animation when the idlewait timer reaches its limit
                    if(player.idlewait != nil and (nonIdle == 0) )
                        local idlewait = player.idlewait
                        if (idlewait < delayer) then
                            player.idlewait = $ + 1
                        else
                            if(idlewait < delayer + 1)
                                mo.state = S_PLAY_ANGLEIDLE
                                player.idlewait = $ + 1
                            end
                        end

                    else
                        player.idlewait = 1
                    end

                -- prevents autoturning when jumping, teetering, springing, or using a vanilla charcter air ability in place, then resets idle timer
                elseif
                (
                    mo.momx == 0
                    and mo.momy == 0
                    and
                    ( --#### Note to self: look into alternate ways of doing this for the possibility of supporting custom abilities.
                        initialState == S_PLAY_JUMP
                        or initialState == S_PLAY_EDGE
                        or initialState == S_PLAY_FALL
                        or initialState == S_PLAY_SPRING
                        or initialState == S_PLAY_GASP
                        or initialState == S_PLAY_FLY
                        or initialState == S_PLAY_FLY_TIRED
                        or initialState == S_PLAY_GLIDE_LANDING
                        or initialState == S_PLAY_SWIM
                        or initialState == S_PLAY_TWINSPIN
                        or initialState == S_PLAY_BOUNCE
                        or initialState == S_PLAY_BOUNCE_LANDING
                        or initialState == S_PLAY_FLOAT

                        or (player.bunsFlightTime != nil and player.bunsFlightBegun != nil and player.bunsFlightTime > 0 and player.bunsFlightBegun == true)	-- Bunnie compatability
                    )
                )
                    player.drawangle = player.prevdrawangle
                    player.idlewait = 0

                -- resets idle timer
                else
                    player.idlewait = 0
                end
            end

        player.prevdrawangle = player.drawangle -- sets the angle for the player to maintain next frame

        if (initialState == S_PLAY_ANGLEIDLE and (player.rmomx != 0 or player.rmomy != 0))
            mo.state = S_PLAY_WALK		-- This line cancels idle animation when the player moves.
        elseif(initialState == S_PLAY_ANGLEIDLE and player.FallingAnimation == true and (not P_IsObjectOnGround(mo)) and (not (player.powers[pw_carry] == CR_ROLLOUT)))	--Falling Animation compatability
            if (mo.momz * P_MobjFlip(mo) < 0) then
                mo.state = S_PLAY_FALL
            else
                mo.state = S_PLAY_SPRING
            end
        end
    end

end, MT_PLAYER)


-- [[ Super Shield Mobjs ]] --

addHook("MobjThinker", function(shield) -- there are so many .valid checks in here, when one goes down i need to patch another >:( don't whine at me for being lazy, blame the game for whining at me
	if not shield.valid return end
	local player
	if shield and shield.valid
		if not shield.target or not shield.target.valid then
			if shield.friendly and shield.friendly.valid then
				shield.friendly.TerminateSelf = true
			end
			P_RemoveMobj(shield)
			--mmtdebuggerPrint("target not found, delet this")
		end

		if shield.valid and shield.TerminateSelf then
		--or (shield.target.valid and shield.target.player.playerstate == PST_DEAD)
			if shield.friendly and shield.friendly.valid then
				shield.friendly.TerminateSelf = true
			end
			P_RemoveMobj(shield)
			--mmtdebuggerPrint("delet this")
		end

		if shield.valid and not shield.TerminateSelf then
			local player = shield.target.player
			if not shield.printed then
				--mmtdebuggerPrint("shield has been summoned")
				shield.printed = true
			end

			-- [ flip ] --
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				shield.flags2 = $1 | MF2_OBJECTFLIP
				shield.eflags = $1 | MFE_VERTICALFLIP
			else
				shield.flags2 = $ & ~MF2_OBJECTFLIP
				shield.eflags = $ & ~MFE_VERTICALFLIP
			end

			P_SetScale(shield, FixedMul(player.mo.scale, player.shieldscale))

			-- [ flop ] --
			if (shield.eflags & MFE_VERTICALFLIP) then
				shield.destinationz = player.mo.z + (player.mo.height - shield.height + FixedDiv(P_GetPlayerHeight(player) - player.mo.height, 3*FRACUNIT)) - FixedMul(2*FRACUNIT, player.mo.scale)
			else
				shield.destinationz = player.mo.z - (FixedDiv(P_GetPlayerHeight(player) - player.mo.height, 3*FRACUNIT)) + FixedMul(2*FRACUNIT, player.mo.scale)
			end

			P_MoveOrigin(shield, player.mo.x, player.mo.y, shield.destinationz)


			if not shield.summonedfriend
				shield.friendly = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_FAKE_SHIELD2)
				shield.friendly.them = player.mo
				shield.friendly.target = shield
				shield.summonedfriend = true
			end

			if shield.PlayerShield != player.powers[pw_shield] and shield.SetState
				shield.SetState = false
				--mmtdebuggerPrint("unset false shield, prepping for new one")
			end

			--[[if (player.pflags & PF_SHIELDABILITY) and not shield.SetShieldAbility
				shield.SetShieldAbility = true
				shield.changesecondstate = true
				mmtdebuggerPrint("player used shield ability")
			end

			if (player.pflags & ~PF_SHIELDABILITY) and shield.SetShieldAbility
				shield.SetShieldAbility = false
				mmtdebuggerPrint("shield ability ended, unsetting shield.SetShieldAbility")
			end]]

			if not shield.DontRender
				if not shield.SetState
					if player.powers[pw_shield] == SH_WHIRLWIND then
						shield.state = S_WIND1
					elseif player.powers[pw_shield] == SH_PITY then
						shield.state = S_PITY1
					elseif player.powers[pw_shield] == SH_ARMAGEDDON then-- create seperate object for S_ARMF1
						shield.state = S_ARMA1
					elseif player.powers[pw_shield] == SH_PINK then -- change skincolor to pink in seperate function
						shield.state = S_PITY1
					elseif player.powers[pw_shield] == SH_ELEMENTAL then -- create seperate object for S_ELEMF1
						shield.state = S_ELEM1
					elseif player.powers[pw_shield] == SH_ATTRACT then
						shield.state = S_MAGN1
					elseif player.powers[pw_shield] == SH_FLAMEAURA then
						shield.state = S_FIRS1
					elseif player.powers[pw_shield] == SH_BUBBLEWRAP then
						shield.state = S_BUBS1
					elseif player.powers[pw_shield] == SH_THUNDERCOIN then
						shield.state = S_ZAPS1
					elseif player.powers[pw_shield] == SH_FORCE then
						shield.state = S_FORC11
					elseif player.powers[pw_shield] == SH_FORCE|1 then
						shield.state = S_FORC1
					elseif player.powers[pw_shield] == SH_NONE then
						shield.state = S_INVISIBLE
					end

					--mmtdebuggerPrint("set new state")
					if player.powers[pw_shield] == SH_PINK
						shield.color = SKINCOLOR_PINK
						shield.colorized = true
					else
						shield.color = SKINCOLOR_NONE
						shield.colorized = false
					end
					shield.changesecondstate = true
					shield.SetState = true
					shield.PlayerShield = player.powers[pw_shield]
				end
			else
				shield.state = S_INVISIBLE
			end

			if not (player.powers[pw_super] or player.powers[pw_invulnerability]) and not shield.DontRender
				--mmtdebuggerPrint("player no longer super, disabling render")
				shield.DontRender = true
			end
		end
	end
end, MT_FAKE_SHIELD)

addHook("MobjThinker", function(shield)
	if not shield.valid return end

	local friend = shield.target

	if shield.TerminateSelf or not shield.them.valid or shield.them.player.playerstate == PST_DEAD then
		P_RemoveMobj(shield)
		--mmtdebuggerPrint("delet this 2")
	end

	local player
	if shield.valid and shield.them and shield.them.valid then
	    player = shield.them.player
	end


	if shield.valid and friend and not shield.TerminateSelf then

		if (friend.eflags & MFE_VERTICALFLIP)
			shield.flags2 = $1 | MF2_OBJECTFLIP
			shield.eflags = $1 | MFE_VERTICALFLIP
		else
			shield.flags2 = $ & ~MF2_OBJECTFLIP
			shield.eflags = $ & ~MFE_VERTICALFLIP
		end


		P_MoveOrigin(shield, friend.x, friend.y, friend.z)

		if not shield.printed then
			--mmtdebuggerPrint("shield2 has been summoned")
			shield.printed = true
		end

		if not friend.DontRender then
			if friend.changesecondstate then
				if player.powers[pw_shield] == SH_ARMAGEDDON then-- create seperate object for S_ARMF1
					shield.state = S_ARMF1
				elseif player.powers[pw_shield] == SH_ELEMENTAL then -- create seperate object for S_ELEMF1
					shield.state = S_ELEMF1
				elseif player.powers[pw_shield] == SH_FLAMEAURA then
					shield.state = S_FIRSB1
				elseif player.powers[pw_shield] == SH_BUBBLEWRAP then
					shield.state = S_BUBSB1
				elseif player.powers[pw_shield] == SH_THUNDERCOIN then
					shield.state = S_ZAPSB1
				else
					shield.state = S_INVISIBLE
				end
				if friend.SetShieldAbility then
					if player.powers[pw_shield] == SH_FLAMEAURA then
						shield.state = mobjinfo[MT_FLAMEAURA_ORB].painstate -- idk how any of this shit works, i can't even find the state used for the shields, stjr plz
					end
				end
				--mmtdebuggerPrint("change second state")
				friend.changesecondstate = false
			end
		else
			shield.state = S_INVISIBLE
		end
	end
end, MT_FAKE_SHIELD2)
